import lotus.domino.*;
import java.util.Vector;

public class Email
{
  private Document ml;
  private Vector recipients = new Vector();
  private boolean hasSubject = false;
  private boolean hasBody = false;

  //Constructor - sets up the mail that will be sent
  Email ( Database db )
    throws NotesException
  {
    ml = db.createDocument();
    ml.replaceItemValue( "Form", "Memo" );
  }

  //Set value of SendTo field (String)
  public void setSendTo( String SendTo )
  {
    recipients.addElement( SendTo );
  }

  //OverLoaded setSendTo method (Vector)
  public void setSendTo( Vector SendTo )
  {
    recipients = SendTo;
  }

  //Set value of CopyTo field
  public void setCopyTo( String CopyTo )
    throws NotesException
  {
    ml.replaceItemValue ( "CopyTo", CopyTo );
  }

  //Set value of ReplyTo field
  public void setReplyTo( String ReplyTo )
    throws NotesException
  {
    ml.replaceItemValue ( "ReplyTo", ReplyTo );
  }

  //Set value of BlindCopyTo field
  public void setBlindCopyTo( String BlindCopyTo )
    throws NotesException
  {
    ml.replaceItemValue ( "BlindCopyTo", BlindCopyTo );
  }

  //Set value of Subject field
  public void setSubject( String Subject )
    throws NotesException
  {
    ml.replaceItemValue ( "Subject", Subject );
    hasSubject = true;
  }

  //Set value of Body rtField (StringBuffer)
  public void setBody( StringBuffer Body )
    throws NotesException
  {
    RichTextItem rt = ml.createRichTextItem( "Body" );
    rt.appendText( Body.toString() );
    hasBody = true;
  }

  //OverLoaded setBody method (String)
  public void setBody( String Body )
    throws NotesException
  {
    RichTextItem rt = ml.createRichTextItem( "Body" );
    rt.appendText( Body );
    hasBody = true;
  }

  //Send the mail to recipient
  public void sendMail ( boolean SaveMail )
    throws NotesException
  {
      if ( ( hasSubject || hasBody) && recipients.isEmpty() == false ) { //no point sending mail otherwise
        ml.setSaveMessageOnSend( SaveMail );
        ml.send( false, recipients ); //send the mail
        ml.recycle();
      }
  }
} ///~)